package com.app.input.personalised.board.helpers

import android.content.Context
import android.graphics.BitmapFactory
import android.graphics.Color
import android.graphics.drawable.BitmapDrawable
import android.graphics.drawable.Drawable
import android.graphics.drawable.StateListDrawable
import android.util.Xml
import androidx.core.content.ContextCompat
import com.app.input.personalised.board.BoartApp
import com.app.input.personalised.board.keyboardutils.KeyboardConfig
import com.app.input.personalised.board.R
import org.xmlpull.v1.XmlPullParser
import java.io.File
import java.io.StringReader
import kotlin.collections.iterator

class ThemeResourceManager(var context: Context) {


    private var textSize = 13f

    var functionDraw: Drawable =
        getDefaultDrawList(R.drawable.key_normal_default, R.drawable.key_pressed_default)
    var generalDraw: Drawable =
        getDefaultDrawList(R.drawable.key_normal_default, R.drawable.key_pressed_default)

    var toDraw: Drawable = getDefaultDrawList(R.drawable.key_normal_default, R.drawable.key_pressed_default)
    var spaceDraw: Drawable = getDefaultDrawList(R.drawable.key_normal_default, R.drawable.key_pressed_default)

    var switchDraw: Drawable? = null
    var deleteDraw: Drawable? = null
    var backDraw: Drawable? = null
    var searchDraw: Drawable? = null

    var shiftDraw: Drawable? = null
    var shiftLockDraw: Drawable? = null

    var keyTextColor: Int = ContextCompat.getColor(context, R.color.black)
    var keyTextColorFunction: Int = ContextCompat.getColor(context, R.color.black)




    fun getConfig(): KeyboardConfig? {
        val skinPath = ThemePreferences.getSkinPath()
        val configFilePath = skinPath + "assets/keyboard.conf"
        val file = File(configFilePath)
        return if (file.exists()) {
            ConfigFileParser.initConfig(configFilePath)
        } else {
            null
        }
    }

    fun getConfigBg(name: String): Drawable? {
        ThemePreferences.getSkinPath()?.let { resPath ->
            val pPath = "${resPath}res/drawable-xhdpi-v4/"

            return getDrawList(
                pPath + name,
                pPath + name
            )
        }
        return null
    }

    fun updateSkinConfig() {
        ThemePreferences.getSkinPath()?.let { resPath ->
            val pPath = "${resPath}res/drawable-xhdpi-v4/"
            pPath.let {
                readColors(resPath) {
                    for ((name, value) in it) {
                        if (name == KeyboardConstants.keyTextColorName) {
                            keyTextColor = value
                        }
                        if (name == KeyboardConstants.keyTextColorFunctionName) {
                            keyTextColorFunction = value
                        }
                    }

                }
                functionDraw = getDrawList(
                    it + KeyboardConstants.functionNormalName,
                    it + KeyboardConstants.functionPressName
                )
                generalDraw = getDrawList(it + KeyboardConstants.normalName, it + KeyboardConstants.pressName)
                toDraw = getDrawList(it + KeyboardConstants.toNormalName, it + KeyboardConstants.toPressName)
                spaceDraw =
                    getDrawList(it + KeyboardConstants.spaceNormalName, it + KeyboardConstants.spacePressName)
                switchDraw =
                    getDrawList(it + KeyboardConstants.imeSwitchName, it + KeyboardConstants.imeSwitchName)
                deleteDraw = getDrawList(
                    it + KeyboardConstants.deleteNormalName,
                    it + KeyboardConstants.deletePressName
                )
                backDraw = getDrawList(it + KeyboardConstants.backName, it + KeyboardConstants.backName)
                searchDraw = getDrawList(it + KeyboardConstants.searchName, it + KeyboardConstants.searchName)
                shiftDraw = getDrawList(
                    it + KeyboardConstants.shiftNormalName,
                    it + KeyboardConstants.shiftNormalName
                )
                shiftLockDraw =
                    getDrawList(it + KeyboardConstants.shiftLockName, it + KeyboardConstants.shiftLockName)
            }

        }
    }


    private fun getDefaultDrawList(normalDrawId: Int, pressDrawId: Int): StateListDrawable {
        val normalDraw = ContextCompat.getDrawable(BoartApp.Companion.boartAppInstance, normalDrawId)
        val pressDraw = ContextCompat.getDrawable(BoartApp.Companion.boartAppInstance, pressDrawId)
        val stateListDrawable = StateListDrawable().apply {
            addState(
                intArrayOf(android.R.attr.state_pressed),
                pressDraw
            )
            addState(intArrayOf(), normalDraw)
        }

        return stateListDrawable


    }


    private fun getDrawList(normalPath: String, pressPath: String): StateListDrawable {
        val pressDraw = BitmapFactory.decodeFile(pressPath)
        val normalDraw = BitmapFactory.decodeFile(normalPath)
        val stateListDrawable = StateListDrawable().apply {
            addState(
                intArrayOf(android.R.attr.state_pressed),
                BitmapDrawable(context.resources, pressDraw)
            )
            addState(intArrayOf(), BitmapDrawable(context.resources, normalDraw))
        }

        return stateListDrawable


    }

    private fun readColors(resPath: String, callBack: (Map<String, Int>) -> Unit) {
        val resMaps = mutableMapOf<String, Int>()

        val pPath = "${resPath}res/colors.xml"
        val file = File(pPath)
        if (file.exists()) {
            val xmlPullParser = Xml.newPullParser().apply {
                setInput(StringReader(file.readText()))
                setFeature(XmlPullParser.FEATURE_PROCESS_NAMESPACES, false)

            }
            var curType = xmlPullParser.eventType
            while (curType != XmlPullParser.END_DOCUMENT) {
                val b = curType == XmlPullParser.START_TAG
                val b1 = xmlPullParser.name == "color"
                val b2 = xmlPullParser.name == "item"
                if (b && (b1 || b2)) {
                    val attributeName = xmlPullParser.getAttributeValue(null, "name")
                    val nextTextValue = xmlPullParser.nextText()
                    val b3 = attributeName == KeyboardConstants.keyTextColorName
                    val b4 = attributeName == KeyboardConstants.keyTextColorFunctionName
                    if (b3 || b4) {
                        resMaps[attributeName] = Color.parseColor(nextTextValue)
                    }
                }
                curType = xmlPullParser.next()
            }

        }

        callBack.invoke(resMaps)


    }


}